summaryrefslogtreecommitdiffstats
path: root/meta/recipes-core
diff options
context:
space:
mode:
authorDamien Lespiau <damien.lespiau@intel.com>2012-09-27 15:20:50 +0100
committerRichard Purdie <richard.purdie@linuxfoundation.org>2012-09-28 11:07:40 +0100
commitffb6928f5783e5202d9849c3a185e29be1d41c63 (patch)
tree9ea6987b1e8f910a8ee4ac270111d5813efec4cc /meta/recipes-core
parent6d3d4baeebc850492d523419683348cffa2d63b0 (diff)
downloadast2050-yocto-poky-ffb6928f5783e5202d9849c3a185e29be1d41c63.zip
ast2050-yocto-poky-ffb6928f5783e5202d9849c3a185e29be1d41c63.tar.gz
initrd: Spawn an emergency shell when something goes wrong
set -e allows to exit if a command fails. We install a trap and execute emergency_shell() when either the init script exits or when ctrl-c is typed (say if we are stuck somewhere and we want to debug it). (From OE-Core rev: ae5e2bd994e3f60d3803ab56e6ed34d08fbc56f0) Signed-off-by: Damien Lespiau <damien.lespiau@intel.com> Signed-off-by: Ross Burton <ross.burton@intel.com> Signed-off-by: Saul Wold <sgw@linux.intel.com> Signed-off-by: Richard Purdie <richard.purdie@linuxfoundation.org>
Diffstat (limited to 'meta/recipes-core')
-rw-r--r--meta/recipes-core/initrdscripts/files/init-live.sh11
1 files changed, 11 insertions, 0 deletions
diff --git a/meta/recipes-core/initrdscripts/files/init-live.sh b/meta/recipes-core/initrdscripts/files/init-live.sh
index 3fba7dc..fb7af31 100644
--- a/meta/recipes-core/initrdscripts/files/init-live.sh
+++ b/meta/recipes-core/initrdscripts/files/init-live.sh
@@ -2,6 +2,17 @@
PATH=/sbin:/bin:/usr/sbin:/usr/bin
+emergency_shell()
+{
+ echo "Bug in initramfs /init detected. Dropping to a shell. Good luck!"
+ echo
+ sh
+}
+trap "emergency_shell" 0 2
+
+# exit immediately if a command fails
+set -e
+
ROOT_MOUNT="/rootfs/"
ROOT_IMAGE="rootfs.img"
MOUNT="/bin/mount"
OpenPOWER on IntegriCloud